﻿-- flagRSP
--
-- based on xTooltip by Author : Per 'Doxxan' Lönn Wege
--


-- flagRSP_CharStatusList = {};
-- flagRSP_IntervalList = {};
-- flagRSP_LastSeenList = {};
-- flagRSP_IntervalListHigh = {};
-- flagRSP_LastSeenListHigh = {};

flagRSP_Debug = false;
flagRSP_DebugSave = false;
flagRSP_AFK = false;
flagRSP_AFKPosx = 0;
flagRSP_AFKPosy = 0;

--[[

flagRSP constants

]]--
-- FLAGRSP_MININTERVAL = 120;
-- FLAGRSP_MAXINTERVAL = 7200;
-- FLAGRSP_MININTERVALHIGH = 30;
-- FLAGRSP_MAXINTERVALHIGH = 1000;
-- FLAGRSP_TARGETMPM = 60;
FLAGRSP_TITLECOLORSTRING = "|cFFFFD100"
FLAGRSP_TITLECOLORSTRINGFL = "|cFFFFFF7F"

--[[

flagRSP library functions.

]]--
FlagRSP = {
	-- oldTick = 0;
	-- numMessagesInInterval = 0;

	-- bytesInInterval = 0;
	-- bytesPerSecondLastInterval = 0;
	-- bytesPerSecondIntervalMax = 0;
	-- bytesPerSession = 0;

	-- ownDescriptionSent = 0;
	-- ownDescriptionRequested = 0;
	-- maxUsersOnline = 0;

	oldestVersion = "";
	newestVersion = "";

	sessionStartTick = 0;
	isInitialized = false;

	maxPostingCost = 147;
	maxPostingCostHigh = 42;
	postingTargetBps = 25;
	postingTargetBpsHigh = 25;

	-- oldTickChatFrame = 0;

	postInterval = 2000;
	postIntervalHigh = 400;
	displayBoxInterval = 10;
	rescaleBoxInterval = 120000;
	rescaleBoxBtnInterval = 120000;
	
	startTime = 0;
	
	postFlagInterval = 60;
	postFlagLast = 0;
	
	canPost = false;

	newTickChatFrame = 0;
	newTickPost = 0;
	newTickPostHigh = 0;
	-- newTickDesc = 0;
	newTickDisplayBox = 0;
	newTickRescaleBox = {
		FlagRSPInfoBox = 0,
		FRIENDLISTFrameInfoBox = 0
	},
	-- newTickRescaleBoxBtn = 0;

	updateFriendsTick = 0;
	updateGuildListTick = 0;
	updateIgnoredListTick = 0;

	pName = "";
	rName = "";

	verMajor = 1;
	verMinor = 2;
	verPatch = 0;
	versionString = "1.2.0";
    versionType = "";

	-- isStableVersion = true;

	VERSION = "";

	notificationSeen = false;
   
	playerEnteredWorld = false;

	standby = false;
	collecting = false;

	displayOwnTooltip = false;
};

flagRSPDetails = {
	name = "flagRSP",
	version = FlagRSP.versionString,
	author = "Typhix, Syeira",
	-- email = "typhix@flagrsp.de",
	-- website = "www.flagrsp.de",
	category = MYADDONS_CATEGORY_OTHERS
};

flagRSPHelp = {};
flagRSPHelp[1] = "For help regarding flagRSP please look into the documentation files contained in <WoW>\\Interface\\AddOns\\flagRSP\\documentation.";


--[[ ==== FlagRSP Class ======================================================================= ]]--

--[[ === Event functions === ]]--

--[[

FlagRSP:OnLoad(frame)

-- A unified version of the OnLoad from the Friendlist and FlagRSP.

]]--
function FlagRSP:OnLoad(frame)
	frame:RegisterEvent("PLAYER_ENTERING_WORLD");
	frame:RegisterEvent("ADDON_LOADED");
	frame:RegisterEvent("VARIABLES_LOADED");  -- Fires when saved variables are loaded
	frame:RegisterEvent("ZONE_CHANGED_NEW_AREA");
	frame:RegisterEvent("ADDON_ACTION_FORBIDDEN");
	frame:RegisterEvent("ADDON_ACTION_BLOCKED");	
	frame:RegisterEvent("CHAT_MSG_SYSTEM");	
	frame:RegisterEvent("UPDATE_MOUSEOVER_UNIT");
	frame:RegisterEvent("PLAYER_TARGET_CHANGED");    
    frame:RegisterEvent("PLAYER_LOGOUT"); 
    
    FlagRSPProtocol:OnLoad();
	
	SlashCmdList["RSP"] = xTooltip_Msg;
	SLASH_RSP1 = "/rsp";
	
	SlashCmdList["RSPAN"] = function () FlagRSP:enableRPTags(); end
	SLASH_RSPAN1 = "/rspan";
	SLASH_RSPAN2 = "/rspon";
	
	SlashCmdList["RSPAUS"] = function () FlagRSP:disableRPTags(); end
	SLASH_RSPAUS1 = "/rspaus";
	SLASH_RSPAUS2 = "/rspoff";

	SlashCmdList["RELOADUI"] = ReloadUI;
	SLASH_RELOADUI1 = "/rui";
	SLASH_RELOADUI2 = "/reloadui";
	
	SlashCmdList["FRIENDLISTCOMMAND"] = FRIENDLIST_SlashHandler;
	SLASH_FRIENDLISTCOMMAND1 = "/fl";
	SLASH_FRIENDLISTCOMMAND2 = "/friendlist";
	
	SlashCmdList["ADD"] = addfriend_Msg;
	SLASH_ADD1 = "/add";
	
	GameTooltip:SetScript("OnTooltipSetUnit", function() self:UpdateTooltip() end);

	FlagRSP_Version = self.versionString;
	self.VERSION = FlagRSP_Version;
end

--[[

- FlagRSP:OnEvent(event, ...)

-- This will handle all the event handlers between the Friendlist and
   FlagRSP.  It's a more unified approach than the previous ones.

]]--
function FlagRSP:OnEvent(event, ...)
	local arg = {...};
	
	if event == "PLAYER_ENTERING_WORLD" then --or event == "ADDON_LOADED" then
		if not self.playerEnteredWorld then

			self.pName, self.rName = FlagRSPConfigure:Initialize();
			FlagHandler:SetRealm(self.rName);

			self.newTickPost = GetTime() + 60;
			self.newTickPostHigh = GetTime() + 50;

			local t = 0;
			while FlagRSP_Locale_OnLoad[t] ~= nil do
				self:printM(TooltipHandler:ParseString(FlagRSP_Locale_OnLoad[t]),1.0, 1.0, 0.0);
				t = t + 1;
			end

			self.sessionStartTick = GetTime();
		 
			if ( FriendlistData == nil and ( friendData == nil or friendData[self.rName] == nil or friendData[self.rName][self.pName] == nil ) ) then
				Friendlist:InitializeData();
			elseif ( friendData ~= nil and FriendlistData == nil ) then
				Friendlist:ConvertToPerCharacterFriendlist();
			end
			
			if ( FlagRSPData == nil and ( FlagRSPSettings == nil or FlagRSPSettings[self.rName] == nil or FlagRSPSettings[self.rName][self.pName] == nil ) ) then
				FlagRSPConfigure:initializeSettings();
			elseif ( FlagRSPData == nil and FlagRSPSettings[self.rName][self.pName] ~= nil ) then
				FlagRSPConfigure:ConvertToPerCharacterSettings();
			end
			
            -- -- Check Version for saved variables
            -- if ( FlagRSPData ~= nil and not FlagRSP:CheckVersionPlugins(FlagRSPData.version) ) then
                -- FlagRSPData = nil;
				-- FlagRSPConfigure:initializeSettings();
                -- FlagRSP:printM("Your flag and settings could be outdated. You should reinitialize them.");
            -- end
            
			if FlagRSPConfigure:GetStandby() then
				self:printM(FlagRSP_Locale_StandBy);
				self:printM(FlagRSP_Locale_StandBy2);
				self:LeaveChannel();
				FlagRSPConfigure:SetStandby(true);
				self.standby = true;
			end
			
			TooltipHandler:buildSkinnableTable();
			FlagRSPInfo:purgeBoxList();
			FlagHandler:purgeFlags();

			if ( FlagRSPConfigure:GetShowTips() ) then
				self:showDYKBox()
			end

			self.playerEnteredWorld = true;
			
			
			FlagRSPConfigure:SetButtonPosition(FlagRSPConfigure:GetButtonPosition());
			if FlagRSPConfigure:GetButtonState() == nil then
				FlagRSPConfigure:SetButtonState(true);
			end
			if FlagRSPConfigure:GetButtonState() then
				FRIENDLISTMinimapButton:Show();
			else
				FRIENDLISTMinimapButton:Hide();	
			end
		end

		if myAddOnsFrame_Register then
			myAddOnsFrame_Register(flagRSPDetails, flagRSPHelp);
		end
	elseif (event == "VARIABLES_LOADED") or (event == "UNIT_NAME_UPDATE" and select(1, ...) == 'player') then
        FlagRSPProtocol_loadMsp();
		
        if not FlagRSPConfigure:isInitialized() then
			return;
		end

		FRIENDLIST_Update();
		
		if ( friendData ~= nil and FriendlistData == nil ) then
			Friendlist:ConvertToPerCharacterFriendlist();
		elseif ( friendData == nil and FriendlistData == nil ) then
			Friendlist:InitializeData();
		end
		
		if ( FlagRSPData == nil and ( FlagRSPSettings == nil or FlagRSPSettings[self.rName] == nil or FlagRSPSettings[self.rName][self.pName] == nil ) ) then
			FlagRSPConfigure:initializeSettings();
		elseif ( FlagRSPData == nil and FlagRSPSettings[self.rName][self.pName] ~= nil ) then
			FlagRSPConfigure:ConvertToPerCharacterSettings();
		end
		
		
		FRIENDLISTMiniMap_OnLoad();
	elseif event == "CHAT_MSG_SYSTEM" then
		if ( self:isAFKEvent(arg[1]) ) then
			if not self.collecting then
				flagRSP_AFK = true;
				self:printM(FlagRSP_Locale_AFK_Activated);
			else
			end
		
			flagRSP_AFKPosx, flagRSP_AFKPosy = GetPlayerMapPosition("player");
			self:printDebug("flagRSP: DEBUG: AFK: x_position: " .. flagRSP_AFKPosx .. " y_position: " .. flagRSP_AFKPosy);
		end
		if ( self:isnotAFKEvent(arg[1]) ) then
			flagRSP_AFK = false;
			self:printM(FlagRSP_Locale_AFK_Deactivated);
		end
		self:checkAFK(arg[2]);

	elseif event == "UPDATE_MOUSEOVER_UNIT" then
		self:UpdateTooltip()
        
		Friendlist:updateEntry("mouseover", "unitID");

		--Grab the name of who we've moused-over
		local name, realm = UnitName("mouseover");
		local guildName = GetGuildInfo("mouseover");
        
        -- Request information protocol   
		if UnitExists("mouseover") and UnitPlayerControlled("mouseover") then
            local request = FlagRSPProtocol:Request("mouseover", "TT");
            FlagRSPProtocol:Update("mouseover", "mouseover", request);
        end
        
		--If they are on our list, update the tooltip and play a sound
		if (Friendlist:isFriend(name)) then
			if (Friendlist:GetFriendstate(name) <= -10) then
				if (FlagRSPConfigure:GetSoundsSetting() == true) then
					if GetTime() > FriendlistFrame.soundTick then 
						PlaySound("igMiniMapZoomIn");
						FriendlistFrame.soundTick = GetTime() + 0.5; 
					end	       
				end
			end
		elseif (Friendlist:isFriend(guildName)) then
			if (Friendlist:GetFriendstate(guildName) <= -10) then
				if (FlagRSPConfigure:GetSoundsSetting() == true) then
	       
					if GetTime() > FriendlistFrame.soundTick then 
						PlaySound("igMiniMapZoomIn");
						FriendlistFrame.soundTick = GetTime() + 0.5; 
					end
				end
			end
		end
	elseif ( event == "ADDON_ACTION_FORBIDDEN" ) then
		if ( select(1, ...) ~= nil and select(2, ...) ~= nil ) then
			if ( select(1, ...) == "flagRSP" or select(1, ...) == "flagRSPLoader" or select(1, ...) == "FriendList" ) then
				local debugMsg;
				debugMsg = "Call stack was: " .. debugstack(3, 2, 3);
--				ChatFrame1:AddMessage("ADDON_ACTION_FORBIDDEN fired.  " .. select(1, ...) .. " attempted to call " .. select(2, ...) .. " when it was protected.");
--				ChatFrame1:AddMessage(debugMsg);
			end
		end
	elseif ( event == "ADDON_ACTION_BLOCKED" ) then
		if ( select(1, ...) ~= nil and select(2, ...) ~= nil ) then
			if ( select(1, ...) == "flagRSP" or select(1, ...) == "flagRSPLoader" or select(1, ...) == "FriendList" ) then
				local debugMsg;
				debugMsg = "Call stack was: " .. debugstack(3, 2, 3);
--				ChatFrame1:AddMessage("ADDON_ACTION_BLOCKED fired.  " .. select(1, ...) .. " attempted to call " .. select(2, ...) .. " when it was protected.");
--				ChatFrame1:AddMessage(debugMsg);
			end
		end
	end
	if ( event == "PLAYER_TARGET_CHANGED" ) then
		local targetName = UnitName("target");

		FlagRSPInfo.targetChanged = true;
      
		-- flokru: I linked hiding of levels in Targetframe to level changing in tooltips.
		if ( FlagRSPConfigure:isInitialized() and FlagRSPConfigure:GetLevelDisplay() == "relative" ) then
			local targetLevel = UnitLevel("target");
			local targetLevelText = "";
			
			if targetLevel > 0 then
				Diff = targetLevel - UnitLevel("player");

				if UnitClassification("target") == "elite" then
					Diff = Diff + 5;
				end

				local r,g,b;
                
				if ( level == -1 or Diff >= 7 ) then
					r = QuestDifficultyColors["impossible"].r;
					g = QuestDifficultyColors["impossible"].g;
					b = QuestDifficultyColors["impossible"].b;
				elseif ( Diff >= 4 ) then
					r = QuestDifficultyColors["verydifficult"].r;
					g = QuestDifficultyColors["verydifficult"].g;
					b = QuestDifficultyColors["verydifficult"].b;
				elseif ( Diff >= -1 ) then
					r = QuestDifficultyColors["difficult"].r;
					g = QuestDifficultyColors["difficult"].g;
					b = QuestDifficultyColors["difficult"].b;
				elseif ( -Diff <= GetQuestGreenRange() ) then
					r = QuestDifficultyColors["standard"].r;
					g = QuestDifficultyColors["standard"].g;
					b = QuestDifficultyColors["standard"].b;
				else
					r = QuestDifficultyColors["trivial"].r;
					g = QuestDifficultyColors["trivial"].g;
					b = QuestDifficultyColors["trivial"].b;
				end
                
				TargetFrame.levelText:SetTextColor(r,g,b);
                
				if ( FlagRSPConfigure:GetLevelDisplay() == "relative" ) then
					if ( level == -1 or Diff >= 10 ) then
						targetLevelText = FlagRSP_Locale_TF_Impossible;
					elseif ( Diff >= 7 ) then
						targetLevelText = FlagRSP_Locale_TF_Estrong;
					elseif ( Diff >= 4 ) then
						targetLevelText = FlagRSP_Locale_TF_Vstrong;
					elseif ( Diff >= 2 ) then
						targetLevelText = FlagRSP_Locale_TF_Strong;
					elseif ( Diff >= -1 ) then
						targetLevelText = FlagRSP_Locale_TF_Equal;
					elseif ( Diff >= -GetQuestGreenRange()) then
						targetLevelText = FlagRSP_Locale_TF_Weak;
					elseif ( Diff >= (-4 -GetQuestGreenRange())) then
						targetLevelText = FlagRSP_Locale_TF_Puny;
					else
						targetLevelText = FlagRSP_Locale_TF_Epuny;
					end
				end

				TargetFrame.levelText:SetText(targetLevelText);
			end
		end
		
		-- Make sure target frame is back to original color
		local TargetFrameTexture = TargetFrame.borderTexture;
		TargetFrameTexture:SetVertexColor(1.0, 1.0, 1.0, TargetFrameTexture:GetAlpha());
      
		Friendlist:updateEntry("target","unitID");

		if UnitExists("target") and UnitPlayerControlled("target") then
			local targetName, targetRealm = UnitName("target");
			local guildName = GetGuildInfo("target");
			local r, g, b, t;

            
            -- Request information from protocol  
            local request = FlagRSPProtocol:Request("target", "IB");
            FlagRSPProtocol:Update("target", "target", request);
    
			if (Friendlist:isFriend(targetName)) then
				r,g,b,t = Friendlist:GetFriendstateInfo(Friendlist:GetFriendstate(targetName));
				TargetFrameTexture:SetVertexColor(r, g, b, TargetFrameTexture:GetAlpha());
				TargetFrameTexture:SetTexture("Interface\\TargetingFrame\\UI-TargetingFrame-Elite");
			elseif (Friendlist:isFriend(guildName)) then
				r,g,b,t = Friendlist:GetFriendstateGuildInfo(Friendlist:GetFriendstate(guildName));
				TargetFrameTexture:SetVertexColor(r, g, b, TargetFrameTexture:GetAlpha());
				TargetFrameTexture:SetTexture("Interface\\TargetingFrame\\UI-TargetingFrame");
			end
		end

		FlagRSPInfo:displayBox("target");
    end
    -- Saving variables at logout
    if ( event == "PLAYER_LOGOUT" ) then
        if ( flagRSP_DebugSave ) then
            FlagRSPData.DEBUG = {};
            FlagRSPData.DEBUG.MSPDATA = {};
            FlagRSPData.DEBUG.MSPDATA = msp;
            -- FlagRSPData.DEBUG.flagRSP_CharStatusList = {};
            -- FlagRSPData.DEBUG.flagRSP_CharStatusList = flagRSP_CharStatusList;
            -- FlagRSPData.DEBUG.flagRSP_IntervalList = {};
            -- FlagRSPData.DEBUG.flagRSP_IntervalList = flagRSP_IntervalList;
            FlagRSPData.DEBUG.FlagRSPInfoBoxList = {};
            FlagRSPData.DEBUG.FlagRSPInfoBoxList = FlagRSPInfoBoxList;
        end
        
        FlagRSPProtocol:OnLogout();                
    end
end

function xTooltip_Msg(msg)

	if string.lower(string.sub(msg, 1, string.len(FlagRSP_Locale_HideNames_Cmd))) == FlagRSP_Locale_HideNames_Cmd then 
		FlagRSP:toggleHideNames();
        FlagRSP:UpdateTooltip();
	elseif string.lower(string.sub(msg, 1, 4)) == "stat" then      
		FlagRSP:plotStats();
	elseif string.lower(string.sub(msg, 1, 7)) == "collect" then    -- TODO Rework
        FlagRSP:printM("Collecting out of order, sorry!");
		-- if FlagRSP.collecting then
			-- FlagRSP:printM(FlagRSP_Locale_NoCollecting);
			-- FlagRSP.collecting = false;
		-- else
			-- FlagRSP:printM(FlagRSP_Locale_Collecting);
			-- FlagRSP.collecting = true;
		-- end
	elseif string.lower(string.sub(msg, 1, 7)) == "welcome" then     
		FlagRSP:showWelcomeBox();
	elseif string.lower(string.sub(msg, 1, 4)) == "tips" then      
		FlagRSP:showDYKBox();
	elseif string.lower(msg) == "standby" then -- TODO Rework
        FlagRSP:printM("Standby out of order, sorry!");
		-- if FlagRSPConfigure:GetStandby() then
			-- FlagRSP:printM(FlagRSP_Locale_NoStandBy);
			-- FlagRSPConfigure:SetStandby(false);
			-- FlagRSP.standby = false;
		-- else
			-- FlagRSP:printM(FlagRSP_Locale_StandBy);
			-- FlagRSP:printM(FlagRSP_Locale_StandBy2);
			-- FlagRSP_LeaveChannel();
			-- FlagRSPConfigure:SetStandby(true);
			-- FlagRSP.standby = true;
		-- end
	elseif string.lower(string.sub(msg, 1, string.len(FlagRSP_Locale_LevelDisp_Cmd))) == FlagRSP_Locale_LevelDisp_Cmd then 
		FlagRSP:toggleLevelDisp();
        FlagRSP:UpdateTooltip();
	elseif string.lower(string.sub(msg, 1, string.len(FlagRSP_Locale_RankDisp_Cmd))) == FlagRSP_Locale_RankDisp_Cmd then
		FlagRSP:toggleRankDisp();
        FlagRSP:UpdateTooltip();
	elseif string.lower(string.sub(msg, 1, string.len(FlagRSP_Locale_GuildDisp_Cmd))) == FlagRSP_Locale_GuildDisp_Cmd then
		FlagRSP:toggleGuildDisp();
        FlagRSP:UpdateTooltip();
	elseif string.lower(string.sub(msg, 1, string.len(FlagRSP_Locale_Beginner_Cmd))) == FlagRSP_Locale_Beginner_Cmd then
		FlagRSP:setRPFlag(4);
        FlagRSPProtocol:UpdateOwn();
		FriendlistCharFrame_Load();
	elseif string.lower(string.sub(msg, 1, string.len(FlagRSP_Locale_Casual_Cmd))) == FlagRSP_Locale_Casual_Cmd then
		FlagRSP:setRPFlag(2);
        FlagRSPProtocol:UpdateOwn();
		FriendlistCharFrame_Load();
	elseif string.lower(string.sub(msg, 1, string.len(FlagRSP_Locale_Normal_Cmd))) == FlagRSP_Locale_Normal_Cmd then
		FlagRSP:setRPFlag(1);
        FlagRSPProtocol:UpdateOwn();
		FriendlistCharFrame_Load();
	elseif string.lower(string.sub(msg, 1, string.len(FlagRSP_Locale_Fulltime_Cmd))) == FlagRSP_Locale_Fulltime_Cmd then
		FlagRSP:setRPFlag(3);
        FlagRSPProtocol:UpdateOwn();
		FriendlistCharFrame_Load();
	elseif string.lower(string.sub(msg, 1, string.len(FlagRSP_Locale_NoRP_Cmd))) == FlagRSP_Locale_NoRP_Cmd then
		FlagRSP:setRPFlag(0);
        FlagRSPProtocol:UpdateOwn();
		FriendlistCharFrame_Load();
	elseif string.lower(string.sub(msg, 1, string.len(FlagRSP_Locale_OOC_Cmd))) == FlagRSP_Locale_OOC_Cmd then
		FlagRSP:setCharStatus(1);
        FlagRSPProtocol:UpdateOwn();
		FriendlistCharFrame_Load();
	elseif string.lower(string.sub(msg, 1, string.len(FlagRSP_Locale_IC_Cmd))) == FlagRSP_Locale_IC_Cmd then
		FlagRSP:setCharStatus(2);
        FlagRSPProtocol:UpdateOwn();
		FriendlistCharFrame_Load();
	elseif string.lower(string.sub(msg, 1, string.len(FlagRSP_Locale_ICFFA_Cmd))) == FlagRSP_Locale_ICFFA_Cmd then
		FlagRSP:setCharStatus(3);
        FlagRSPProtocol:UpdateOwn();
		FriendlistCharFrame_Load();
	elseif string.lower(string.sub(msg, 1, string.len(FlagRSP_Locale_ST_Cmd))) == FlagRSP_Locale_ST_Cmd then
		FlagRSP:setCharStatus(4);
        FlagRSPProtocol:UpdateOwn();
		FriendlistCharFrame_Load();
	elseif string.lower(string.sub(msg, 1, string.len(FlagRSP_Locale_NoCStatus_Cmd))) == FlagRSP_Locale_NoCStatus_Cmd then
		FlagRSP:setCharStatus(0);
        FlagRSPProtocol:UpdateOwn();
		FriendlistCharFrame_Load();
	elseif string.lower(string.sub(msg, 1, string.len(FlagRSP_Locale_Status_Cmd))) == FlagRSP_Locale_Status_Cmd then
		FlagRSP:plotStatus();
	elseif string.lower(msg) == "toggletooltip" then 
		if ( FlagRSPConfigure:GetTooltipStyle() == "normal" ) then
			FlagRSP:printM(FlagRSP_Locale_LightModifyTooltip);
			FlagRSPConfigure:SetTooltipStyle("light");
		elseif ( FlagRSPConfigure:GetTooltipStyle() == "light" ) then
			FlagRSP:printM(FlagRSP_Locale_NoModifyTooltip);
			FlagRSPConfigure:SetTooltipStyle("none");
		elseif ( FlagRSPConfigure:GetTooltipStyle() == "none" ) then
			FlagRSP:printM(FlagRSP_Locale_ModifyTooltip);
			FlagRSPConfigure:SetTooltipStyle("normal");
		end
        --FlagRSP:UpdateTooltip();
	elseif string.lower(string.sub(msg, 1, string.len("purgeinterval"))) == "purgeinterval" then
		FlagRSP:printDebug("new purge interval: " .. string.sub(msg, string.len("purgeinterval")+2, string.len(msg)));
		if string.len(msg) > string.len("purgeinterval")+1 then
			local n = tonumber(string.sub(msg, string.len("purgeinterval")+2, string.len(msg)));
			if n ~= nil then
				FlagRSPSettings.FlagPurgeInterval = n*86400;
				FlagRSP:printDebug("new purge interval (set): " .. FlagRSPSettings.FlagPurgeInterval);
				local msg = string.gsub(FlagRSP_Locale_PurgeInterval, "%%s", n);
				FlagRSP:printM(msg);
			end
		else
			local msg = string.gsub(FlagRSP_Locale_PurgeInterval, "%%s", math.floor(FlagRSPSettings.FlagPurgeInterval/86400*10)/10);
			FlagRSP:printM(msg);
		end	 
	elseif string.lower(msg) == "purge" then
		FlagHandler:purgeAllFlags();
        FlagRSPProtocol:UpdateOwn();
	elseif string.lower(string.sub(msg, 1, 6)) == "toggle" then -- TODO Rework 
        FlagRSP:printM("Toggling Flag off is out of order, sorry!");
		-- if FlagRSPConfigure:GetRPFlag() == 0 then
			-- FlagRSP:setRPFlag(5);
		-- else
			-- FlagRSP:setRPFlag(0);
		-- end
	elseif string.lower(string.sub(msg, 1, string.len(FlagRSP_Locale_Surname_Cmd))) == FlagRSP_Locale_Surname_Cmd then -- TODO Rework
        FlagRSP:printM("Set surname is out of order, sorry!");
		-- FlagRSP:setSurname(string.sub(msg, string.len(FlagRSP_Locale_Surname_Cmd)+2, string.len(msg)));
	elseif string.lower(string.sub(msg, 1, string.len(FlagRSP_Locale_Firstname_Cmd))) ==  FlagRSP_Locale_Firstname_Cmd then -- TODO Rework
        FlagRSP:printM("Set first name is out of order, sorry!");
		-- FlagRSP:SetName(string.sub(msg, string.len(FlagRSP_Locale_Firstname_Cmd)+2, string.len(msg)));
    -- TODO Chat command for entering fullname is missing!
	elseif string.lower(string.sub(msg, 1, string.len(FlagRSP_Locale_Title_Cmd))) == FlagRSP_Locale_Title_Cmd then
		FlagRSP:setTitle(string.sub(msg, string.len(FlagRSP_Locale_Title_Cmd)+2, string.len(msg)));
        FlagRSPProtocol:UpdateOwn();
		FriendlistCharFrame_Load();
	elseif string.lower(string.sub(msg, 1, string.len(FlagRSP_Locale_AFK_Cmd))) == FlagRSP_Locale_AFK_Cmd then -- TODO Rework
        FlagRSP:printM("FlagRSP-afk is out of order, sorry!");
		-- SendChatMessage(string.sub(msg, string.len(FlagRSP_Locale_AFK_Cmd)+2, string.len(msg)), "AFK");
	elseif string.lower(string.sub(msg, 1, string.len("edit"))) == "edit" then -- TODO Rework
        FlagRSP:printM("Friendlist-command \"edit\" is out of order, sorry!");
		-- FRIENDLIST_ToggleGUI();
		-- Friendlist_TabHandler(2);
	elseif string.lower(string.sub(msg, 1, string.len("uinames"))) == "uinames" then
		FlagRSP:printDebug(GetCVar("UnitNamePlayer"));
		if GetCVar("UnitNameFriendlyPlayerName") == "1" then
			FlagRSP:printM(FlagRSP_Locale_UINamesDisabled);
			SetCVar("UnitNameFriendlyPlayerName","0");
			SetCVar("UnitNameEnemyPlayerName","0");
		elseif GetCVar("UnitNameFriendlyPlayerName") == "0" then
			FlagRSP:printM(FlagRSP_Locale_UINamesEnabled);
			SetCVar("UnitNameFriendlyPlayerName","1");
			SetCVar("UnitNameEnemyPlayerName","1");
		end
	elseif string.lower(string.sub(msg, 1, string.len("alwaysinfobox"))) == "alwaysinfobox" then
		if FlagRSPConfigure:GetInfoBoxState() then
			FlagRSP:printM(FlagRSP_Locale_InfoBoxTradBehaviour);
			FlagRSPConfigure:SetInfoBoxState(false);
		else 
			FlagRSP:printM(FlagRSP_Locale_AlwaysShowInfoBox);
			FlagRSPConfigure:SetInfoBoxState(true);
		end
	elseif string.lower(string.sub(msg, 1, string.len("resetbutton"))) == "resetbutton" then
		FlagRSPConfigure:SetInfoBoxButtonCoords(-1, -1);
	elseif string.lower(string.sub(msg, 1, string.len(FlagRSP_Locale_OwnTooltip_Cmd))) == FlagRSP_Locale_OwnTooltip_Cmd then
		if not FlagRSP.displayOwnTooltip then
			FlagRSP.displayOwnTooltip = true;
			FlagRSP:showOwnTooltip();
		else
			FlagRSP.displayOwnTooltip = false;	 
		end
	elseif string.lower(string.sub(msg, 1, 9)) == "debugsave" then
		if flagRSP_DebugSave then
			FlagRSP:printM("Left debug saving mode.",1.0, 1.0, 0.0);
			flagRSP_DebugSave = false;
		else
			FlagRSP:printM("Entered debug saving mode.",1.0, 1.0, 0.0);
			flagRSP_DebugSave = true;
		end
	elseif string.lower(string.sub(msg, 1, 5)) == "debug" then
		if flagRSP_Debug then
			FlagRSP:printM("Left debug mode.",1.0, 1.0, 0.0);
			flagRSP_Debug = false;
		else
			FlagRSP:printM("Entered debug mode.",1.0, 1.0, 0.0);
			flagRSP_Debug = true;
		end
	-- TODO: Add in Locale strings for these options.
	elseif ( string.lower(string.sub(msg, 1, string.len("coloredlevels"))) == "coloredlevels" ) then -- TODO Rework
        FlagRSP:printM("FlagRSP-afk is out of order, sorry!");
		-- if ( FlagRSPData.colorLevelText ) then
			-- FlagRSPData.colorLevelText = false;
			-- FlagRSP:printM("colorLevelText set to false");
		-- else
			-- FlagRSPData.colorLevelText = true;
			-- FlagRSP:printM("colorLevelText set to true");
		-- end
        FlagRSP:UpdateTooltip();
	elseif ( string.lower(string.sub(msg, 1, string.len("classcolor"))) == "classcolor" ) then 
		if ( FlagRSPConfigure:GetClassColor() ) then
			FlagRSPConfigure:SetClassColor(false);
			FlagRSP:printM("colorClassText set to false");
		else
			FlagRSPConfigure:SetClassColor(true);
			FlagRSP:printM("colorClassText set to true");
		end
        FlagRSP:UpdateTooltip();
	elseif ( string.lower(string.sub(msg, 1, string.len("guildrank"))) == "guildrank" ) then
		if ( FlagRSPConfigure:GetGuildRank() ) then
			FlagRSPConfigure:SetGuildRank(false);
			FlagRSP:printM("showGuildRank set to false");
		else
			FlagRSPConfigure:SetGuildRank(true);
			FlagRSP:printM("showGuildRank set to true");
		end
	elseif ( string.lower(string.sub(msg, 1, string.len("resetinfobox"))) == "resetinfobox" ) then
		FlagRSPInfo:resetPosition();
	else
		local t = 0;
		while FlagRSP_Locale_Help[t] ~= nil do
			DEFAULT_CHAT_FRAME:AddMessage(FlagRSP_Locale_Help[t],1.0, 1.0, 1.0);
			t = t + 1;
		end
	end
end


--[[ === Settings of own flag === ]]--

--[[ Sets the char status and prints an info message
]]--
function FlagRSP:setCharStatus(status)
	local mesg;
	local changed = false;

	if status ~= FlagRSPConfigure:GetCharacterStatus() then
		if status == 1 then 
			mesg = FlagRSP_Locale_OOCFlag;
		elseif status == 2 then 
			mesg = FlagRSP_Locale_ICFlag;
		elseif status == 3 then 
			mesg = FlagRSP_Locale_FFAICFlag;
		elseif status == 0 then 
			mesg = FlagRSP_Locale_NoCFlag;
		elseif status == 4 then
			mesg = FlagRSP_Locale_STFlag;
		end
		
		FlagRSPConfigure:SetCharacterStatus(status);
      
		self:printM(mesg);
		changed = true;
	end

	return changed;
end 

--[[ Sets the description and prints an info message 
]]--
function FlagRSP:setDesc(desc)
	local changed = false;
	if desc ~= FlagRSPConfigure:GetDescription() then
		FlagRSPConfigure:SetRevision(FlagRSPConfigure:GetRevision() + 1);
		FlagRSPConfigure:SetDescription(desc);

		self:printM(FlagRSP_Locale_DescUpdate);

		changed = true;
	end

	return changed;
end

--[[ Sets the full name and prints info messages
    - Uses character name as default, if no name is given
]]--
function FlagRSP:setFullname(name)
	local changed = false;
	
	if ( string.len(name) > 150 ) then
		name = string.sub(name, 1, 150);
	end
	
	if ( name ~= FlagRSPConfigure:GetFullname() ) then
		FlagRSPConfigure:SetFullname(name);
		
		if ( name == " " or name == "" or name == UnitName("player") ) then
			-- Using default name
			local msg = string.gsub(FlagRSP_Locale_NoAltName, "%%s", UnitName("player"));
			self:printM(msg);
		else
			-- Using other, own name
			local msg = string.gsub(FlagRSP_Locale_NewAltName, "%%s", name);
			self:printM(msg);
		end
		
		changed = true;
	end
	
	return changed;
end

function FlagRSP:SetName(name) -- TODOSY Remove, shouln'd be necessary
	local changed = false;
	
	if ( string.len(name) > 50 ) then
		name = string.sub(name, 1, 50);
	end
	
	if ( name ~= FlagRSPConfigure:GetName() ) then
        local player,_ = UnitName("player");
		FlagRSPConfigure:SetName(name);
		
		if ( name == " " or name == "" or name == UnitName("player") ) then
			-- Print a message or something saying no first name.
			local msg = string.gsub(FlagRSP_Locale_NoAltName, "%%s", UnitName("player"));
			self:printM(msg);
		else
			-- Print another message that you have an alternate first name.
			local msg = string.gsub(FlagRSP_Locale_NewAltName, "%%s", name);
			self:printM(msg);
		end
		
		changed = true;
	end
	
	return changed;
end

function FlagRSP:setSurname(name)
	local changed = false;

	if string.len(name) > 50 then
		name = string.sub(name,1,50);
	end

	if name ~= FlagRSPConfigure:GetSurname() then
		FlagRSPConfigure:SetSurname(name);
      
		if name == " " or name == "" then
			self:printM(FlagRSP_Locale_NoSurname);
		else
            local player = UnitName("player");
			local msg = string.gsub(FlagRSP_Locale_NewSurname, "%%s", name);
			self:printM(msg);
		end

		changed = true;
	end

	return changed;
end

--[[ Sets a title and prints an info message
]]--
function FlagRSP:setTitle(title)
	local changed = false;

	if string.len(title) > 100 then
		title = string.sub(title,1,100);
	end
	if title ~= FlagRSPConfigure:GetTitle() then
		FlagRSPConfigure:SetTitle(title);

		if strtrim(title) == "" then
			self:printM(FlagRSP_Locale_NoTitle);
		else
			local msg = string.gsub(FlagRSP_Locale_NewTitle, "%%s", title);
			self:printM(msg);
		end
      
		changed = true;
	end

	return changed;
end   


--[[ === Flag Config === ]]--

function FlagRSP:enableRPTags()
	self:setRPFlag(5);
	self:setNameDisp(true);
	FlagRSPConfigure:SetLevelDisplay("relative");
   
	-- flokru: Name and title notification, a bit quick and dirty.
	if FlagRSPConfigure:GetSurname() ~= nil then
		self:setSurname(FlagRSPConfigure:GetSurname());
	end
	if FlagRSPConfigure:GetTitle() ~= nil then
		self:setTitle(FlagRSPConfigure:GetTitle());
	end
end
   
function FlagRSP:disableRPTags()
	self:setRPFlag(0);
	self:setNameDisp(false);
	self:setLevelDisp("none");

	-- flokru: However, we should give a notification here as well, so that
	--         players notice that there are still tags set.
	-- flokru: Name and title notification, a bit quick and dirty.
	if FlagRSPConfigure:GetSurname() ~= nil then
		self:setSurname(FlagRSPConfigure:GetSurname());
	end
	if FlagRSPConfigure:GetTitle() ~= nil then
		self:setTitle(FlagRSPConfigure:GetTitle());
	end
   
end

--[[

FlagRSP:checkAFK(chatAuthor)

- Checks if player is still afk. If player is moving or entering chat 
  messages afk will be disabled.  
- Argument chatAuthor will be checked against player name.

]]--
function FlagRSP:checkAFK(chatAuthor)
	local posx, posy = GetPlayerMapPosition("player");

	if flagRSP_AFK then
		if chatAuthor ~= nil and chatAuthor ~= "" then
			self:printDebug("flagRSP: DEBUG: Chat author: " .. chatAuthor);
		end
      
		if chatAuthor == UnitName("player") then
			self:printDebug("flagRSP: DEBUG: Player sent chat message, AFK will be disabled.");
		end
      
		if posx ~= flagRSP_AFKPosx or posy~= flagRSP_AFKPosy then
			self:printDebug("flagRSP: DEBUG: Player moved, AFK will be disabled.");
		end
	end
end

--[[

FlagRSP:playerIsIgnored(name)

- Checks, if player name is ignored.
- Returns true if ignored, false if not.

]]--
function FlagRSP:playerIsIgnored(name)
	local isIgnored = false;

	for t = 1, GetNumIgnores() do
		local iName = GetIgnoreName(t);
		if iName == name then 
			isIgnored = true; 	
			break; 
		end
	end

	return isIgnored;
end

--[[

FlagRSP:toggleRankDisp()

- Toggles displaying of PvP ranks.

]]--
function FlagRSP:toggleRankDisp()
	if not FlagRSPConfigure:GetPVPRanks() then
		self:setRankDisp(true);
	else
		self:setRankDisp(false);
	end
end

--[[

FlagRSP:toggleGuildDisp()

- Toggles displaying of guild names in tooltip.

]]--
function FlagRSP:toggleGuildDisp()
	if self:getGuildDisp() == 0 then
		self:setGuildDisp(1);
	elseif self:getGuildDisp() == 1 then
		self:setGuildDisp(-1);
	elseif self:getGuildDisp() == -1 then
		self:setGuildDisp(0);
	end
end

--[[

FlagRSP:setRankDisp()

- Sets rank display.

]]--
function FlagRSP:setRankDisp(value)
	local mesg;

	if value == 0 then value = false; end
	if value == 1 then value = true; end
   
	if value ~= true and value ~= false then return; end

	if value then
		mesg = FlagRSP_Locale_ShowRanks;
		FlagRSPConfigure:SetPVPRanks(true);
	else
		mesg = FlagRSP_Locale_HideRanks;
		FlagRSPConfigure:SetPVPRanks(false);
	end

	self:printM(mesg);
end

--[[

FlagRSP:setGuildDisp()

- Sets guild display.

]]--
function FlagRSP:setGuildDisp(value)
	local mesg;

	if value == false then value = -1; end
	if value == true then value = 1; end

	if value ~= 1 and value ~= -1 and value ~= 0 then return; end

	if value == 1 then
		mesg = FlagRSP_Locale_ShowAllGuild;
		FlagRSPConfigure:SetGuildDisplay("all");
	elseif value == -1 then
		mesg = FlagRSP_Locale_HideGuild;
		FlagRSPConfigure:SetGuildDisplay("none");
	elseif value == 0 then
		mesg = FlagRSP_Locale_ShowKnownGuild;
		FlagRSPConfigure:SetGuildDisplay("known");
	end

	self:printM(mesg);
end

--[[

FlagRSP:getGuildDisp()

- Gets guild display option.
-- Dirty hack to keep this compatible.
-- TODO: Fix whatever calls this to use "all", "known", "none" instead of numbers.

]]--
function FlagRSP:getGuildDisp()
	local state;
	local number = -1; -- Defaults to display no guilds.
	
	state = FlagRSPConfigure:GetGuildDisplay();
	
	if ( state == "all" ) then
		number = 1;
	elseif ( state == "known" ) then
		number = 0;
	end
	
	return number;
end

--[[

FlagRSP:plotStatus()

- Gives an overview over all settings.

]]--
function FlagRSP:plotStatus()
	self:setRPFlag(FlagRSPConfigure:GetRPFlag());
	self:setCharStatus(FlagRSPConfigure:GetCharacterStatus());
	self:setNameDisp(self:getNameDisp());
	self:setLevelDisp(self:getLevelDisp());
	self:setRankDisp(FlagRSPConfigure:GetPVPRanks());
	self:setGuildDisp(self:getGuildDisp());
	self:setSurname(FlagRSPConfigure:GetSurname());
	self:setTitle(FlagRSPConfigure:GetTitle());
end

--[[

FlagRSP:showOwnTooltip()

- Shows the tooltip for the player.

]]--
function FlagRSP:showOwnTooltip()
	local tt = getglobal("GameTooltip");

	local ttline = getglobal("GameTooltipTextLeft1"):GetText();
   
	if not tt:IsVisible() or string.find(ttline, self.pName) == nil then
		tt:SetOwner(UIParent, "ANCHOR_NONE");
		tt:SetPoint("TOP", "UIParent", "TOP", 0, -32);
      
		tooltipLinesLeft = {};
		tooltipLinesLeft[1] = "";
		tooltipLinesRight = {};
      
		tt:SetBackdropColor(TooltipHandler:getTooltipBGColor("player"));
		local modifier = self:GetModifier(nil, "player")
		TooltipHandler:BuildTooltip(modifier, nil, "player")
		tt:Show();
	end
end

--[[

FlagRSP:printDebug(msg)

- Gives a debug message msg.

]]--
function FlagRSP:printDebug(msg)
	if flagRSP_Debug and msg ~= nil then
		ChatFrame4:AddMessage("|CFF" .. self:getHexString(1*255,2) .. self:getHexString(1*255,2) .. self:getHexString(0.5*255,2) .. "<flagRSP> DEBUG:|r " .. msg,1,1,1);
	end
end


--[[

FlagRSP:getVersionNum(ver)

- Converts version string <ver> into numbers.

]]--
function FlagRSP:getVersionNum(ver)
	local release, major, minor, dotPos;
    
    local addition = "";
    if ( string.find(ver,"%a") ) then
        ver, addition = strsplit(" ",ver,2);
    end
	dotPos = string.find(ver, "%.");
	if dotPos ~= nil then 
		release = tonumber(string.sub(ver, 1, dotPos-1)); 
		ver = string.sub(ver, dotPos+1, string.len(ver));
	else 
		release = -1; 
	end
   
	dotPos = string.find(ver, "%.");
	if dotPos ~= nil then 
		major = tonumber(string.sub(ver, 1, dotPos-1));
		ver = string.sub(ver, dotPos+1, string.len(ver));
	else
		major = -1; 
	end

	minor = tonumber(string.sub(ver, 1, string.len(ver)));

	if minor == nil then
		minor = -1;
	end
   
   
	return release, major, minor;
end

--[[

FlagRSP:checkVersion(ver)

- Checks for a new version of flagRSP.

]]--
function FlagRSP:checkVersion(ver)

	local release, major, minor = self:getVersionNum(ver);
   
	local oR, oMj, oMn = self:getVersionNum(self.oldestVersion);
	local nR, nMj, nMn = self:getVersionNum(self.newestVersion);

	local newVersion = false;

	if release ~= nil and major ~= nil and minor ~= nil and release >= 0 and major >= 0 and minor >= 0 then
		if release > self.verMajor then
			newVersion = true;
		elseif major > self.verMinor and release == self.verMajor then
			newVersion = true;
		elseif minor > self.verPatch and major == self.verMinor and release == self.verMajor then
			newVersion = true;
		end

		if release > nR then
			self.newestVersion = ver;
		elseif major > nMj and release == nR then
			self.newestVersion = ver;
		elseif minor > nMn and major == nMj and release == nR then
			self.newestVersion = ver;
		end

		if oR == -1 or oMj == -1 or oMn == -1 then
			self.oldestVersion = ver;
		end
      
		if release < oR then
			self.oldestVersion = ver;
		elseif major < oMj and release == oR then
			self.oldestVersion = ver;
		elseif minor < oMn and major == oMj and release == oR then
			self.oldestVersion = ver;
		end      
	end


	if newVersion then      
		self:printDebug("New version available");
		self:showVersionNotification(release, major, minor);
	end
end

function FlagRSP:showVersionNotification(r, m, n)
	if not UnitAffectingCombat("player") and FlagRSPConfigure.GetVersionNotification and not self.notificationSeen then
		FlagRSPNewVersionNotification:SetWidth(450);
		FlagRSPNewVersionNotification:SetHeight(100);
		FlagRSPNewVersionNotification:Show();
		FlagRSPNewVersionNotification:SetBackdropColor(0,0,0,0.9);

		local text = FlagRSP_Locale_NewVersionText;
      
		text = string.gsub(text, "%%r", r)
		text = string.gsub(text, "%%m", m)
		text = string.gsub(text, "%%n", n)

		FlagRSPNewVersionNotificationTitleText:SetText(FlagRSP_Locale_NewVersionTitle);
		FlagRSPNewVersionNotificationText:SetText(text);
		FlagRSPNewVersionNotificationCheckButtonText:SetText(FlagRSP_Locale_NewVersionCheckButton);
		FlagRSPNewVersionNotificationText:SetWidth(410);

		FlagRSPNewVersionNotificationText:SetTextHeight(14);
		FlagRSPNewVersionNotification:SetScale(2);
		FlagRSPNewVersionNotification:SetScale(1);

		FlagRSPNewVersionNotificationCheckButton:SetPoint("BOTTOMLEFT", FlagRSPNewVersionNotification:GetName(), "BOTTOMLEFT", 20, FlagRSPNewVersionNotificationAccept:GetHeight()+20);

		FlagRSPNewVersionNotification:SetPoint("TOP", "UIParent", "TOP", 0, -150);
		FlagRSPNewVersionNotification:SetPoint("BOTTOM", "UIParent", "TOP", 0, -220-FlagRSPNewVersionNotificationText:GetHeight()-FlagRSPNewVersionNotificationAccept:GetHeight()-FlagRSPNewVersionNotificationCheckButton:GetHeight());
	

		self.notificationSeen = true;
	end
end

function FlagRSP:showEditBox(message)
	FlagRSPDescWarnBox.warning = "givenname";
	if ( message == nil ) then
		message = FlagRSP_Locale_DescWarnText;
		FlagRSPDescWarnBox.warning = "description";
    end
    FlagRSPDescWarnBox:SetWidth(550);
    FlagRSPDescWarnBox:SetHeight(100);
    FlagRSPDescWarnBox:Show();
    FlagRSPDescWarnBox:SetBackdropColor(0,0,0,0.9);
    
    FlagRSPDescWarnBoxTitleText:SetText(FlagRSP_Locale_DescWarnTitle);
    FlagRSPDescWarnBoxText:SetText(message);
    FlagRSPDescWarnBoxText:SetWidth(510);

    FlagRSPDescWarnBoxText:SetTextHeight(12);
    FlagRSPDescWarnBox:SetScale(2);
    FlagRSPDescWarnBox:SetScale(1);
    
    FlagRSPDescWarnBoxAccept:SetScript("OnClick", FlagRSPDescWarnBoxAccept_OnClick);

    FlagRSPDescWarnBox:SetPoint("TOP", "UIParent", "TOP", 0, -150);
    FlagRSPDescWarnBox:SetPoint("BOTTOM", "UIParent", "TOP", 0, -220-FlagRSPDescWarnBoxText:GetHeight()-FlagRSPDescWarnBoxAccept:GetHeight());
    
end

function FlagRSP:showDYKBox(nextTip)
	if nextTip == nil then
		nextTip = false;
	end

	FlagRSPDYKBox:SetWidth(550);
	FlagRSPDYKBox:SetHeight(100);
	FlagRSPDYKBox:Show();
	FlagRSPDYKBox:SetBackdropColor(0,0,0,0.9);
   
	if FlagRSPConfigure:GetShowTips() then
		FlagRSPDYKBoxCheckButton:SetChecked(0);
	else
		FlagRSPDYKBoxCheckButton:SetChecked(1);
	end
   
	local text = FlagRSP_Locale_TipText[math.random(1,table.getn(FlagRSP_Locale_TipText))];

	FlagRSPDYKBoxCheckButtonText:SetText(FlagRSP_Locale_DYKCheckText);
   
	FlagRSPDYKBoxTitleText:SetText(FlagRSP_Locale_DYKTitle);
	FlagRSPDYKBoxText:SetText(text);
	FlagRSPDYKBoxText:SetWidth(510);
   
	FlagRSPDYKBoxAccept:Hide();  
   
	FlagRSPDYKBoxText:SetTextHeight(12);
	FlagRSPDYKBox:SetScale(2);
	FlagRSPDYKBox:SetScale(1);
   
	FlagRSPDYKBoxCheckButton:SetPoint("BOTTOMLEFT", "FlagRSPDYKBox", "BOTTOMLEFT", 20, FlagRSPDYKBoxClose:GetHeight()+20); 
   
	FlagRSPDYKBox:SetPoint("TOP", "UIParent", "TOP", 0, -150);
	FlagRSPDYKBox:SetPoint("BOTTOM", "UIParent", "TOP", 0, -220-FlagRSPDYKBoxText:GetHeight()-FlagRSPDYKBoxAccept:GetHeight()- FlagRSPDYKBoxCheckButton:GetHeight());
   
end

function FlagRSP:showWelcomeBox(full)
	FlagRSPWelcomeBox:SetWidth(550);
	FlagRSPWelcomeBox:SetHeight(100);
	FlagRSPWelcomeBox:Show();
	FlagRSPWelcomeBox:SetBackdropColor(0,0,0,0.9);
   
	local text
	if full then
		text = TooltipHandler:ParseString(FlagRSP_Locale_WelcomeHeader .. FlagRSP_Locale_WelcomeText);-- .. FlagRSP_Locale_WelcomeHomepage ..  FlagRSP_Locale_WelcomeChanges);
	else
		text = TooltipHandler:ParseString(FlagRSP_Locale_WelcomeHeader);-- .. FlagRSP_Locale_WelcomeHomepage .. FlagRSP_Locale_WelcomeChanges);
	end

	FlagRSPWelcomeBoxTitleText:SetText(FlagRSP_Locale_WelcomeTitle);
	FlagRSPWelcomeBoxText:SetText(text);
	FlagRSPWelcomeBoxText:SetWidth(510);

	FlagRSPWelcomeBoxText:SetTextHeight(12);
	FlagRSPWelcomeBox:SetScale(2);
	FlagRSPWelcomeBox:SetScale(1);

	FlagRSPWelcomeBox:SetPoint("TOP", "UIParent", "TOP", 0, -150);
	FlagRSPWelcomeBox:SetPoint("BOTTOM", "UIParent", "TOP", 0, -220-FlagRSPWelcomeBoxText:GetHeight()-FlagRSPWelcomeBoxAccept:GetHeight());
end

function FlagRSP:setNameDisp(value)
	local mesg;

	if value == 0 then value = false; end
	if value == 1 then value = true; end

	if value ~= true and value ~= false then return; end

	if value then
		mesg = FlagRSP_Locale_HideNames;
		FlagRSPConfigure:SetNameDisplay(true);
	else
		mesg = FlagRSP_Locale_UnhideNames;
		FlagRSPConfigure:SetNameDisplay(false);
	end

	self:printM(mesg);
end

function FlagRSP:getNameDisp()
	return FlagRSPConfigure:GetNameDisplay();
end

function FlagRSP:setLevelDisp(value)
	local mesg;

	if ( value == "none" ) then
		mesg = FlagRSP_Locale_HideLevels;
		FlagRSPConfigure:SetLevelDisplay("relative");
	elseif ( value == "relative" ) then
		mesg = FLagRSP_Locale_ColoredLevels;
		FlagRSPConfigure:SetLevelDisplay("color");
	else
		mesg = FlagRSP_Locale_UnhideLevels;
		FlagRSPConfigure:SetLevelDisplay("none");
	end

	self:printM(mesg);
end

function FlagRSP:getLevelDisp()
	return FlagRSPConfigure:GetLevelDisplay();
end

function FlagRSP:setRPFlag(RPType)
	local mesg;
	local changed = false;

	if RPType < 0 or RPType > 5 then return; end

	if RPType ~= FlagRSPConfigure:GetRPFlag() then
		if RPType == 0 then
			-- flokru: Now we save roleplaying behaviour before unsetting rp-flag.
			if FlagRSPConfigure:GetRPFlag() ~= 0 then
				FlagRSPConfigure:SetOldRPFlag(FlagRSPConfigure:GetRPFlag());
			end
			mesg = FlagRSP_Locale_NoRPFlagSet;
		elseif RPType == 1 then
			mesg = FlagRSP_Locale_NormalRPFlagSet;
		elseif RPType == 2 then
			mesg = FlagRSP_Locale_CasualFlagSet;
		elseif RPType == 3 then
			mesg = FlagRSP_Locale_FulltimeFlagSet;
		elseif RPType == 4 then
			mesg = FlagRSP_Locale_BeginnerFlagSet;
		elseif RPType == 5 then
			-- flokru: I love recursion :)
			if FlagRSPConfigure:GetOldRPFlag() ~= nil then
				self:setRPFlag(FlagRSPConfigure:GetOldRPFlag());
			else
				self:setRPFlag(1);
			end
			return;
		end
      
      
		self:printM(mesg);
		FlagRSPConfigure:SetRPFlag(RPType);

		changed = true;
	end

	return changed;
end

function FlagRSP:GetModifier(tooltipUnit, tooltipBase)
	local modifier = "";
	if (UnitIsPlayer(tooltipUnit)) then
		if (not self:getNameDisp() or TooltipHandler:playerIsKnown(UnitName(tooltipUnit))) then
			modifier = "known";
		elseif (self:playerIsIgnored(UnitName(tooltipUnit))) then
			modifier = "ignored";
		else
			modifier = "unknown";
		end
	else
		if (TooltipHandler:isPet(tooltipUnit)) then
			modifier = "pet";
		else
			modifier = "npc";
		end
	end
	return modifier;
end

function FlagRSP:AddTooltipLine(textline)
	local temp;
	local alreadyIn = false;
	for i = 1, GameTooltip:NumLines() do
		temp = getglobal("GameTooltipTextLeft"..i):GetText();
		if (textline == temp) then
			alreadyIn = true
		end
	end
	if (not alreadyIn) then
		GameTooltip:AddLine(textline, 1, 1, 1);
	end
end

--[[

- FlagRSP:UpdateTooltip()

-- Updates the tooltip with the roleplaying data.

]]--
function FlagRSP:UpdateTooltip()
	-- Check the type of style the user has set.
	local tooltipBase = "GameTooltip";	
	local tooltipUnit = "mouseover";

	if UnitName(tooltipUnit) == nil then
		return;
	end
	if ( FlagRSPConfigure:GetTooltipStyle() == "normal" ) then
		-- Perform the standard tearing down and rebuilding of the tooltip.

		GameTooltip:SetBackdropColor(TooltipHandler:getTooltipBGColor(tooltipUnit));
		
		local modifier = self:GetModifier(tooltipUnit, tooltipBase)
		if (modifier == "ignored") then
			getglobal(tooltipBase):SetBackdropColor(1,0,0);
		elseif (modifier == "npc") then
			TooltipHandler:ParseNPCTooltip();
		end

		TooltipHandler:BuildTooltip(modifier, tooltipBase, tooltipUnit);
	elseif ( FlagRSPConfigure:GetTooltipStyle() == "light" ) then
		-- This is only a lightly modified tooltip.
		if UnitIsPlayer(tooltipUnit) or UnitPlayerControlled(tooltipUnit) then
			local unitName, unitRealm = UnitName(tooltipUnit);
			local name;
			if UnitPVPRank(tooltipUnit) ~= nil and GetPVPRankInfo(UnitPVPRank(tooltipUnit), tooltipUnit) ~= nil then
				name = GetPVPRankInfo(UnitPVPRank(tooltipUnit), tooltipUnit) .. " " .. UnitName(tooltipUnit);
			else
			    name = GameTooltipTextLeft1:GetText(); -- shows title and name
                -- name = UnitName(tooltipUnit);
			end
			local surname = "";--TooltipHandler:getSurname(name);
            local fullname = "";
			local title = TooltipHandler:getTitle(unitName);
			local rpflag = TooltipHandler:getRPTooltipText(unitName, tooltipUnit);
			local cstatus = TooltipHandler:getCharStatusTooltipText(unitName, tooltipUnit);
			local friendstate = Friendlist:GetFriendstateText(unitName);
	 
			local r, g, b = GameTooltip_UnitColor(tooltipUnit);
			GameTooltipTextLeft1:SetText("|CFF" .. self:GetHex(r, g, b) .. name .. " " .. surname);
			self:AddTooltipLine(title);
			self:AddTooltipLine(rpflag);
			self:AddTooltipLine(cstatus);
			self:AddTooltipLine(friendstate);
			
			GameTooltip:Show();
		else
			local name = GameTooltipTextLeft1:GetText();
			local r, g, b = GameTooltip_UnitColor(tooltipUnit);
			if name ~= nil then
				GameTooltipTextLeft1:SetText("|CFF" .. self:GetHex(r, g, b) .. name);
			end
		end
	else
		local name = GameTooltipTextLeft1:GetText();
		local r, g, b = GameTooltip_UnitColor(tooltipUnit);
		if name ~= nil then
			GameTooltipTextLeft1:SetText("|CFF" .. self:GetHex(r, g, b) .. name);
		end
	end
end

-- function FlagRSP:getStats()
	-- local t = 0;
	-- local o = 0;
	-- local oMax = 0;

	-- local style;
	-- local lastSeen;
	-- local interval;
	-- for name, interv in pairs(flagRSP_IntervalList) do
		-- t = t + 1;
      
		-- if flagRSP_LastSeenList[name] ~= nil then
			-- lastSeen = flagRSP_LastSeenList[name];
			-- interval = interv;
		-- end
		-- if flagRSP_IntervalListHigh[name] ~= nil and flagRSP_LastSeenListHigh[name] ~= nil then
			-- lastSeen = flagRSP_LastSeenListHigh[name];
			-- interval = flagRSP_IntervalListHigh[name];
		-- end
      
		-- if lastSeen ~= nil and interval ~= nil then
			-- if GetTime() <= interval*2+lastSeen then
				-- o = o + 1;
				-- oMax = oMax + 1;
			-- end
		-- else
			-- oMax = oMax + 1;
		-- end
	-- end

	-- if o > self.maxUsersOnline then
		-- self.maxUsersOnline = o;
	-- end

	-- FlagRSPConfigure:SetOnlineListEntry(FlagRSPConfigure:GetOnlineListPosition(), oMax);
   
	-- return t, o, oMax;
-- end

function FlagRSP:plotStats()
	self:printM("|CFFFFFF7FFLAGRSP STATISTICS:|r");

	self:printM("|CFFFFFF7FMemory statistics:|r");

    UpdateAddOnMemoryUsage()
	local memory, gcTreshold = gcinfo();
	self:printM("Memory used by complete interface (including addons): |CFFFFFF7F" .. math.ceil(memory*10)/10 .. "|r kB.");
	self:printM("Memory used by flagRSP: |CFFFFFF7F" .. math.ceil(GetAddOnMemoryUsage("flagRSP")) .. "|r kB.");
	-- self:printM("Memory used by flagRSP Profile: |CFFFFFF7F" .. math.ceil(GetAddOnMemoryUsage("flagRSP_profiles")) .. "|r kB.");
	-- self:printM("Memory used by flagRSP xtensionxtooltip: |CFFFFFF7F" .. math.ceil(GetAddOnMemoryUsage("flagRSP_xtensionxtooltip")) .. "|r kB.");
	
    local numEntries, flags = FlagHandler:getStats();
	self:printM("|CFFFFFF7FRP flags used:|r");
	self:printM("Number of currently saved entries (i.e. characters) on all realms: |CFFFFFF7F" .. numEntries.. "|r.");
	self:printM("Number of flagRSP users without flag: |CFFFFFF7F" .. flags[0] .. "|r.");
	self:printM("Number of flagRSP users with standard flag: |CFFFFFF7F" .. flags[1] .. "|r.");
	self:printM("Number of flagRSP users with casual flag: |CFFFFFF7F" .. flags[2] .. "|r.");
	self:printM("Number of flagRSP users with fulltime flag: |CFFFFFF7F" .. flags[3] .. "|r.");
	self:printM("Number of flagRSP users with beginner flag: |CFFFFFF7F" .. flags[4] .. "|r.");

end

--[[

FlagRSP:OnUpdate(elapsed)

-- OnUpdate Handler

]]--
function FlagRSP:OnUpdate(elapsed)
	self:checkAFK("");
	FlagRSPConfigure:initializeSettings();
	
	-- Saves on calls to GetTime().
	local curTime = GetTime();
	
	if ( self.startTime == 0 ) then
		self.startTime = curTime;
	elseif ( not self.isInitialized and curTime > ( self.startTime + 30 ) ) then
		self.isInitialized = true;
		self:printM(FlagRSP_Locale_Initialized);
	end
	
	if ( curTime > self.newTickDisplayBox ) then
		FlagRSPInfo:displayBox("target");
		self.newTickDisplayBox = curTime + self.displayBoxInterval;
	end
	
	if ( self.displayOwnTooltip ) then
		self:showOwnTooltip();
	end
	
	if ( curTime > ( self.postFlagLast + self.postFlagInterval ) ) then
		self.canPost = true;
		self.postFlagLast = curTime;
	end
	
	if ( curTime > self.newTickChatFrame ) then
		self.newTickChatFrame = curTime + 60;
	end

	if ( curTime > self.updateFriendsTick ) then
		TooltipHandler:updateFriendEntries();
		self.updateFriendsTick = curTime + 30;
	end

	if ( curTime > self.updateGuildListTick ) then
		TooltipHandler:updateGuildMembers();
		self.updateGuildListTick = curTime + 300;
	end

	if ( curTime > self.updateIgnoredListTick ) then
		TooltipHandler:updateIgnoredList();
		self.updateIgnoredListTick = curTime + 30;
	end

	-- flokru: Targetframe updates on several events. I don't know which.
	--         So, we change level in targetframe here. Not an optimal solution.
	if ( FlagRSPConfigure:isInitialized() and FlagRSPConfigure:GetLevelDisplay() == "relative" ) then
		if UnitName("target") ~= nil then
			local targetLevel = UnitLevel("target");
			local targetLevelText = "";
			if targetLevel > 0 then
				local Diff = targetLevel - UnitLevel("player");
	    
				if UnitClassification("target") == "elite" then
					Diff = Diff + 7;
				end
	    
				if Diff <= -7 then targetLevelText = FlagRSP_Locale_TF_Epuny; end
				if Diff <= -5 and Diff > -7 then targetLevelText = FlagRSP_Locale_TF_Puny; end
				if Diff < -1 and Diff > -5 then targetLevelText = FlagRSP_Locale_TF_Weak; end
				if Diff >= -1 and Diff <= 1 then targetLevelText = FlagRSP_Locale_TF_Equal; end
				if Diff > 1 and Diff < 4 then targetLevelText = FlagRSP_Locale_TF_Strong; end
				if Diff >= 4 and Diff < 7 then targetLevelText = FlagRSP_Locale_TF_Vstrong; end
				if Diff >= 7 and Diff < 10 then targetLevelText = FlagRSP_Locale_TF_Estrong; end
				if Diff >= 10 then targetLevelText = FlagRSP_Locale_TF_Impossible; end
				if targetLevel == -1 then targetLevelText = FlagRSP_Locale_TF_Impossible; end

				TargetFrame.levelText:SetText(targetLevelText);
			end
		end
	end
end

function FlagRSP:isAFKEvent(arg1)
	local msg = arg1;
	if ( string.find(msg,FlagRSP_Locale_AFK) ) then
		return true;
	end
	return false;
end

function FlagRSP:isnotAFKEvent(arg1)
	local msg = arg1;
	if (string.find(msg,FlagRSP_Locale_NOTAFK)) then
		return true;
	end
	return false;
end

function FlagRSP:transformCharFlag(id)
    if ( id == "1" or id == 1 ) then -- ooc
        return "ooc";
    elseif ( id == "2" or id == 2 ) then -- ic
        return "ic";
    elseif ( id == "3" or id == 3 ) then -- ffa-ic
        return "ffa-ic";
    elseif ( id == "4" or id == 4 ) then -- st
        return "st";
    else
        -- return "none";
        return "";
    end
end

function FlagRSP:toggleHideNames()
	if not self:getNameDisp() then
		self:setNameDisp(true);
	else
		self:setNameDisp(false); 
	end
end

function FlagRSP:toggleLevelDisp()
	local display = self:getLevelDisp();
	
	if ( display == "none" ) then
		self:setLevelDisp("relative");
	elseif ( display == "relative" ) then
		self:setLevelDisp("color");
	else
		self:setLevelDisp("none");
	end
end

function FlagRSPNewVersionNotificationCheckButton_OnClick()
	local checkState = FlagRSPNewVersionNotificationCheckButton:GetChecked();
	
	if checkState == nil then
		FlagRSPConfigure:SetVersionNotification(true)
	elseif checkState == 1 then
		FlagRSPConfigure:SetVersionNotification(false);
	end
end

function FlagRSPDYKBoxCheckButton_OnClick()
	local checkState = FlagRSPDYKBoxCheckButton:GetChecked();
	
	if checkState == nil then
		FlagRSPConfigure:SetShowTips(true);
	elseif checkState == 1 then
		FlagRSPConfigure:SetShowTips(false);
	end
end

function FlagRSPDescWarnBoxAccept_OnClick()
	FlagRSPDescWarnBox:Hide();
    
	if ( FlagRSPDescWarnBox.warning == "description" ) then
		FlagRSPData.descBoxWarningSeen = true;
	else
		FlagRSPData.nameBoxWarningSeen = true;
	end
end

function FlagRSPWelcomeBoxAccept_OnClick()
	FlagRSPWelcomeBox:Hide();

	if FlagRSPConfigure:GetShowTips() then
		FlagRSP:showDYKBox();
	end
end

function FlagRSP:CheckVersionPlugins(versionTable)
    if ( versionTable ~= nil ) then
        if ( versionTable.release < FlagRSP.verMajor ) then
            return false;
        elseif ( versionTable.major < FlagRSP.verMinor ) then
            return false;
        elseif ( versiontable.minor < FlagRSP.verPatch ) then
            return false;
        end
        return true;  
    else
        return false;
    end  
end

--[[ === Help functions === ]]--

--[[

FlagRSP:getHexString(num)

- Returns hex number as string with minimum string length len for positive integer num.

]]--
function FlagRSP:getHexString(num, len)
	local digits = "0123456789ABCDEF";
	local hexnum = "";
	local intdigit;

	while num > 0 do
		num = math.floor(num);
		intdigit = math.fmod(num, 16);
		num = math.floor(num/16);

		hexnum = string.sub(digits, (intdigit+1), (intdigit+1)) .. hexnum;
	end

	while string.len(hexnum) < len do
		hexnum = "0" .. hexnum;
	end
   
	return hexnum;
end

function FlagRSP:simplehash(s)
	local a = 378551;
	local b = 63689;
	local h = 0;

	for i=1, string.len(s) do
		h = h * a + string.byte(s,i);
		a = a * b;
	end

	return h;
end

--[[

FlagRSP:GetHex(red, green, blue)

-- Takes in three decimal color values and outputs one hex string.
   Mostly just to save typing space, however this function will be used
   more often.

]]--
function FlagRSP:GetHex(red, green, blue)
	local hexstring = "";
	
	hexstring = self:getHexString(red*255, 2) .. self:getHexString(green*255, 2) .. self:getHexString(blue*255, 2);
	
	return hexstring;
end

--[[

FlagRSP:print(msg)

- Prints message msg.

]]--
function FlagRSP:print(msg, frame)
	if frame == nil then
		frame = DEFAULT_CHAT_FRAME;
	end

	frame:AddMessage(msg,1,1,0);
end

--[[

FlagRSP:printM(msg)

-- Prints message msg in flagRSP style.

]]--
function FlagRSP:printM(msg)
	DEFAULT_CHAT_FRAME:AddMessage("|CFF" .. self:getHexString(1*255,2) .. self:getHexString(1*255,2) .. self:getHexString(0.5*255,2) .. "<flagRSP>|r " .. tostring(msg),1,1,1);
end

--[[

FlagRSP:printE(msg)

-- Prints error message msg in flagRSP style.

]]--
function FlagRSP:printE(msg)
	DEFAULT_CHAT_FRAME:AddMessage("|CFF" .. self:getHexString(1*255,2) .. self:getHexString(1*255,2) .. self:getHexString(0.5*255,2) .. "<flagRSP>|r|CFF" .. self:getHexString(1*255,2) .. self:getHexString(0*255,2) .. self:getHexString(0*255,2) .. "<ERROR>|r" .. msg,1,1,1);
end

--[[

FlagRSP:printA(msg)

-- Prints assertion message msg in flagRSP style.

]]--
function FlagRSP:printA(number)
	self:printM("|Cffff0000ASSERTION #" .. number .. " FAILED!|r Please contact flagRSP developer!");
end
